/*************************************************************************
  Copyright (c) 1993 - 1997
  Digital Equipment Corporation, Maynard, Mass.

  This software is furnished under a license and may be used and  copied
  only  in  accordance  with  the  terms  of  such  license and with the
  inclusion of the above copyright notice.  This software or  any  other
  copies  thereof may not be provided or otherwise made available to any
  other person.  No title to and ownership of  the  software  is  hereby
  transferred.

  The information in this software is subject to change  without  notice
  and  should  not  be  construed  as  a commitment by DIGITAL Equipment
  Corporation.
 *************************************************************************/


/*++
* =============
* = example.c =
* =============
*
* Description:
*   This application demonstrates a simple CBR example.
*
* Arguments:
*   none.
*
* Authors:
*   TLR - Theodore L. Ross
*
* Modification History:
*   Date          Name     Description
*   22-Sep-1996   TLR      Created.
*
* Issues:
*   none.
--*/

#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netatm/atm.h>
#include <sys/errno.h>


main ()
   {
   int          sock;
   char         buff[100];
   ATM_PVC      pvc_info;
   ATM_PARAMS   atm_info;

   printf ("[ Creating Client Socket ]\n");

   sock = socket (AF_ATM, SOCK_DGRAM, 0);

   if (sock == -1)
      {
      printf ("[ socket call failed, error: %d ]\n", errno);
      exit (1);
      }

   printf ("[ Assigning ATM Parameters (optional)]\n");

   /* Initialize atm_info to all default values. */

   ATM_DEFAULTS (&atm_info);

   atm_info.fqos        = ATM_QOS_CLASSA;
   atm_info.bqos        = ATM_QOS_CLASSA;
   atm_info.valid_rates = ATM_VCRV_FPEAK0 | ATM_VCRV_BPEAK0;
   atm_info.fpeakcr[0]  = 167;   /* 64000 bits/sec */
   atm_info.bpeakcr[0]  = 167;
   atm_info.flags       = ATM_SERVICES_CBR;

   if (ioctl (sock, SIO_ATM_PARAMETERS, &atm_info) == -1)
      {
      printf ("[ ioctl call failed, error: %d ]\n", errno);
      exit (1);
      }

   printf ("[ Associating PVC ]\n");

   strncpy (pvc_info.driver, "lta0", 16);
   pvc_info.vpi = 0;
   pvc_info.vci = 1000;

   if (ioctl (sock, SIO_ASSOCIATE_PVC, &pvc_info) == -1)
      {
      printf ("[ ioctl call failed, error: %d ]\n", errno);
      exit (1);
      }

   printf ("[ Sending Text Message ]\n");

   strcpy (buff, "Socket Message - Via ATM Datagram Communication");
   send (sock, buff, strlen (buff), 0);

   printf ("[ Awaiting Reply ]\n");

   while (recv (sock, buff, 100, 0) < 0);

   printf ("[ Message Received: '%s' ]\n", buff);
   }
